HDU 2680 Choose the best route <迪杰斯特拉算法>

来源:互联网 发布:开源企业软件 编辑:程序博客网 时间:2024/06/05 06:27

Choose the best route

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10578    Accepted Submission(s): 3403


Problem Description
One day , Kiki wants to visit one of her friends. As she is liable to carsickness , she wants to arrive at her friend’s home as soon as possible . Now give you a map of the city’s traffic route, and the stations which are near Kiki’s home so that she can take. You may suppose Kiki can change the bus at any station. Please find out the least time Kiki needs to spend. To make it easy, if the city have n bus stations ,the stations will been expressed as an integer 1,2,3…n.
 

Input
There are several test cases.
Each case begins with three integers n, m and s,(n<1000,m<20000,1=<s<=n) n stands for the number of bus stations in this city and m stands for the number of directed ways between bus stations .(Maybe there are several ways between two bus stations .) s stands for the bus station that near Kiki’s friend’s home.
Then follow m lines ,each line contains three integers p , q , t (0<t<=1000). means from station p to station q there is a way and it will costs t minutes .
Then a line with an integer w(0<w<n), means the number of stations Kiki can take at the beginning. Then follows w integers stands for these stations.
 

Output
The output contains one line for each data set : the least time Kiki needs to spend ,if it’s impossible to find such a route ,just output “-1”.
 

Sample Input
5 8 51 2 21 5 31 3 42 4 72 5 62 3 53 5 14 5 122 34 3 41 2 31 3 42 3 211
 

Sample Output
1-1
 

Author
dandelion
 

Source
2009浙江大学计算机研考复试(机试部分)——全真模拟
 
思路:
 
        这道题由于终点有1个,而起点有多个,所以要从反向进行考虑,将终点考虑成起点,起点考虑成终点,然后在输入的时候因为题上说明是有方向的,所以要将起点和终点反过来进行赋值,(要是不这样做会超时!)具体看代码:
 
代码:
 
//这一道题要将终点考虑成起点,起点考虑成终点,这样会节省时间,因为终点就一个,而起点有多个,当你考虑终点到起点的//时候,你就只需要调用一次dijkstra()函数,而你直接考虑起点到终点的话你就需要调用s次dijkstra()函数,会造成超时,并且//在这道题中,路是有方向的,所以你就必须考虑方向,不考虑方向就会出错! #include <stdio.h>#include <string.h>#include <algorithm>using namespace std;#define INF 0x3f3f3f3fint map[1005][1005];int vis[1005];int dis[1005];int n,m,s;int w,x;void init(){memset(map,INF,sizeof(map));int a,b,c;for(int i=1;i<=m;i++){scanf("%d%d%d",&a,&b,&c);if(c<map[b][a])   map[b][a]=c;}}void dijkstra(int x){    memset(vis,0,sizeof(vis));    for(int i=1;i<=n;i++)    {    dis[i]=map[s][i];    }    dis[s]=0;    vis[s]=1;    int min;    int k;for(int i=1;i<=n;i++){min=INF;for(int j=1;j<=n;j++){if(!vis[j]&&dis[j]<min){min=dis[j];k=j;}}if(min==INF)break;vis[k]=1;for(int j=1;j<=n;j++){if(!vis[j]&&dis[j]>dis[k]+map[k][j]){dis[j]=dis[k]+map[k][j];}}}}int main(){while(scanf("%d%d%d",&n,&m,&s)!=EOF){init();dijkstra(x);scanf("%d",&w);int mini=INF;for(int i=1;i<=w;i++){scanf("%d",&x);mini=mini>dis[x]?dis[x]:mini;}if(mini==INF)printf("-1\n");elseprintf("%d\n",mini);}return 0;} 

0 0
原创粉丝点击